#!/usr/local/bin/perl
#----------------------------------------------------
# result.pl
#----------------------------------------------------
# --Acquires user requests for viewing option pricing
# --Generates plots of option valuation results on the fly
#----------------------------------------------------


require "/home/B6H/development/deneb_cgi-bin/miloje/cgi_handlers.pl";

&html_header("Option Valuation Setup");
&get_request;

#$MC_ROOT="/home/B8E/miloje/Demo/Option/Demo/Scripts";
#$SCRIPT_ROOT="/home/B8E/miloje/Demo/Option/Demo/Scripts";

$SCRIPT_ROOT_URL = "http://deneb.npac.syr.edu:3768/cgi-bin/miloje/Demo/tmp";
$TMP_DIR = "/home/B6H/development/document_root/users/miloje/Demo/tmp";
$TMP_URL = "http://deneb.npac.syr.edu:3768/users/miloje/Demo/tmp";
$MC_ROOT="/home/B8E/miloje/Demo/PIMC";

$optfile="$MC_ROOT/$rqpairs{'datafile'}";
$plot = $rqpairs{'PlotType'};
$contract = $rqpairs{'Contract'};
$what = $rqpairs{'What'};
$StrikePrice = $rqpairs{'StrikePrice'};
$UnderlyingPrice = $rqpairs{'UnderlyingPrice'};
$time = $rqpairs{'TimeStep'};
$symbol = $rqpairs{'symbol'};

if(-e $optfile) {
  $_ = `wc -l $optfile`;
  ($ndata, $junk) = /(\d+) (\w+)/;
} else {
  print "Could not find option pricing results, try again"
};

$pid = $$;

$index1=0;
$index2=0;
$index3=0;

open(OPTION_DATA,$optfile) || die "Could not open simulation data file\n";;
while(<OPTION_DATA>) {

 if (/^Option (.*)/) {

    $_ = $1;
    ($nt,$price,$strike)=split;

 } else {

    ($t,$call,$call_err,$call_delta,$call_delta_err,$put,$put_err,$put_delta,$put_delta_err) = split;

    if($plot == 1) {

      if(($strike == $StrikePrice) && ($price == $UnderlyingPrice)) {

        $x[$index1] = $t;

        $yc[$index1] = $call;
        $yp[$index1] = $put;
        $ycd[$index1] = $call_delta;
        $ypd[$index1] = $put_delta;
        
        $zc[$index1] = $call_err;
        $zp[$index1] = $put_err;
        $zcd[$index1] = $call_delta_err;
        $zpd[$index1] = $put_delta_err;

        $index1++;
      }

    }

    if($plot == 2) {

      if(($time == $t) && ($price == $UnderlyingPrice)) {

        $x[$index2] = $strike;

        $yc[$index2] = $call;
        $yp[$index2] = $put;
        $ycd[$index2] = $call_delta;
        $ypd[$index2] = $put_delta;

        $zc[$index2] = $call_err;
        $zp[$index2] = $put_err;
        $zcd[$index2] = $call_delta_err;
        $zpd[$index2] = $put_delta_err;


        $index2++;
      }
    }


    if($plot == 3) {

      if(($time == $t) && ($strike == $StrikePrice)) {

        $x[$index3] = $price;

        $yc[$index3] = $call;
        $yp[$index3] = $put;
        $ycd[$index3] = $call_delta;
        $ypd[$index3] = $put_delta;

        $zc[$index3] = $call_err;
        $zp[$index3] = $put_err;
        $zcd[$index3] = $call_delta_err;
        $zpd[$index3] = $put_delta_err;

        $index3++;
      }
    }

     
 }
 
}

$gnu_file = "$symbol.$pid.gnu";
$plot_data = "option.$symbol.$pid.dat";
$ppm_chartfile = "option.$symbol.$pid.ppm";
$gif_chartfile = "option.$symbol.$pid.gif";
$gif_chartURL  = "$TMP_URL/option.$symbol.$pid.gif";


open(CHART_DATA, ">$TMP_DIR/$plot_data") || die "couldn't open $plot_data";
$index = 0;
$nx = $#x;

if($contract eq "CALL" && $what eq "PRICE") {
  $title = "Call Price";
  while($index <= $nx) {
   print(CHART_DATA "$x[$index]\t $yc[$index] $zc[$index]\n");
   $index++;
  }
}

if($contract eq "CALL" && $what eq "DELTA") {
  $title = "Call Delta";
  while($index <= $nx) {
   print(CHART_DATA "$x[$index] $ycd[$index] $zcd[$index]\n");
   $index++;
  }
}

if($contract eq "PUT" && $what eq "PRICE") {
  $title = "Put Price";
  while($index <= $nx) {
   print(CHART_DATA "$x[$index] $yp[$index] $zp[$index]\n");
   $index++;
  }
}

if($contract eq "PUT" && $what eq "DELTA") {
  $title = "Put Delta";
  while($index <= $nx) {
   print(CHART_DATA "$x[$index] $ypd[$index] $zpd[$index]\n");
   $index++;
  }
}

close(CHART_DATA);

open(OUTPUT, ">$TMP_DIR/$gnu_file") || die "couldn't open $gnu_file";
print(OUTPUT "set term pbm small \n");
# the default size 1, 1 produces a 640x480 size chart...
print(OUTPUT "set size 0.72, 0.54\n");
print(OUTPUT "cd \"$TMP_DIR\"\n");
print(OUTPUT "set grid\n");
print(OUTPUT "set output \"$ppm_chartfile\" \n");
print(OUTPUT "set title \"$title\" \n");
print(OUTPUT "plot \"$plot_data\" with errorbars \n");
close(OUTPUT);
eval `rm -f $TMP_DIR/$ppm_chartfile`;
eval `gnuplot $TMP_DIR/$gnu_file`;
eval `rm -f $TMP_DIR/$gif_chartfile`;
eval `/usr/local/bin/netpbm/ppmtogif $TMP_DIR/$ppm_chartfile > $TMP_DIR/$gif_chartfile`;
print "<hr>";
print "<img src=\"$TMP_URL/$gif_chartfile\">";
eval `rm -f *.ppm *.dat *.gnu`;
print "</body>";
print "</html>";

exit;

